Index: trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/src/G4QEnvironment.cc
===================================================================
--- trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/src/G4QEnvironment.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/src/G4QEnvironment.cc	(revision 1055)
@@ -28,6 +28,6 @@
 //
 //
-// $Id: G4QEnvironment.cc,v 1.137 2008/03/31 20:30:00 dennis Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4QEnvironment.cc,v 1.144 2009/05/26 14:40:20 mkossov Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //      ---------------- G4QEnvironment ----------------
@@ -35,4 +35,12 @@
 //  class for Multy Quasmon Environment used by the CHIPS Model
 // ------------------------------------------------------------
+// Short description: The G4QEnvironment class corresponds to the nuclear
+// environment,  containing excited nucleons or nuclear clusters
+// (G4Quasmons). In the constructer the nucleus (G4QNucleus) is clusterized
+// and then the projectile hadron (or hadrons) can create one (or a few)
+// Quasmons, which are fragmented by the Fragment member function. As a
+// result a vector of G4QHadrons is created, which can include the residual
+// nucleus in the ground state.
+//---------------------------------------------------------------------
  
 //#define debug
@@ -66,5 +74,5 @@
   tot4Mom=G4LorentzVector(0.,0.,0.,envM);
 #ifdef debug
-		G4cout<<"G4QEnviron::Const: t4M="<<tot4Mom<<",tC="<<totCharge<<",tB="<<totBaryoN<<G4endl;
+  G4cout<<"G4QEnviron::Const: t4M="<<tot4Mom<<",tC="<<totCharge<<",tB="<<totBaryoN<<G4endl;
 #endif
 }
@@ -88,5 +96,5 @@
     //throw G4QException("***G4QEnvironment: There is no one projectile or vacuum target");
     if(nHadrons)                             // The projectiles are copied to the output
-	   {
+    {
       for(G4int ih=0; ih<nHadrons; ih++)
       {
@@ -99,5 +107,5 @@
         theProjectiles.push_back(curQH);      // Remenber it for the error message
       }
-	   }
+    }
     else if(targPDG!=90000000)               // No projHadrons,fill targetNucleus to output
     {
@@ -165,5 +173,5 @@
 #endif
     if(nHadrons==1)
-	   {
+    {
       G4QHadron* opHad=projHadrons[0];
       G4int opPDG=opHad->GetPDGCode();
@@ -172,5 +180,5 @@
 #endif
       if(opPDG==22)                           // *** Check photon's NuclearSplitThreshold
-	     {
+      {
         G4double exMass=tot4Mom.m();
 #ifdef pdebug
@@ -178,9 +186,9 @@
 #endif      
         if(exMass<targM+135.977) // Nucleus is below the pion production threshold
-	       {
+        {
           G4QNucleus exEnviron(tot4Mom,targPDG);
           // @@ One can put here the pbpt= (M.K.) @@ What about d,t,alpha splitting?
           if(targM>999.&&!exEnviron.SplitBaryon())//Nucleus is below SplitFragmentThreshold
-		        {
+          {
 #ifdef pdebug
             G4cout<<"G4QEnv::Const:Photon's added to Output, Env="<<theEnvironment<<G4endl;
@@ -192,7 +200,7 @@
             theQHadrons.push_back(photon);      // (delete equivalent)
             return;
-		        }
+          }
           else if(targM<=999.)                  // Target is a nucleon
-	         {
+          {
             G4LorentzVector prot4m(0.,0.,0.,targM); // Prototype of secondary proton 4mom
             G4LorentzVector gam4m(0.,0.,0.,0.);     // Prototype for secondary gamma 4mom
@@ -222,8 +230,8 @@
       }
       else if(opPDG==13 || opPDG==15)
-	     {
+      {
         G4int         nuPDG=14;
         if(opPDG==15) nuPDG=16;
-		      G4LorentzVector mu4m=opHad->Get4Momentum();
+        G4LorentzVector mu4m=opHad->Get4Momentum();
         //G4double qpen=-180.*log(G4UniformRand()); // Energy of target-quark-parton(T=180)
         G4double qpen=465.*sqrt(sqrt(G4UniformRand())); // UniformDistr for 3-q nucleon
@@ -268,6 +276,6 @@
           G4cout<<"--G4QEnv::Const:M="<<tm<<",GSM=="<<fnm<<G4endl;
 #endif
-		      }
-		      fnN.Set4Momentum(fn4m);
+        }
+        fnN.Set4Momentum(fn4m);
         // (mu,q->nu,q) reaction succeded and Neutrino can be pushed to Output
         G4QHadron* neutrino = 0;              // NeutrinoPrototype to be filled to Output
@@ -276,5 +284,5 @@
 #endif      
         if(tm<fnm)                            // Final Nucleus is below the GS threshold
-		      {
+        {
           qf4m=G4LorentzVector(0.,0.,0.,fnm); // Final nucleus 4M for the final decay
           qt4m=tg4m+mu4m;
@@ -303,7 +311,7 @@
         theQHadrons.push_back(neutrino);      // (delete equivalent)
         if(tm<fnm+135.98)                     // FinalNucleus is below thePionThreshold(HE)
-	       {
+        {
           if(!fnN.SplitBaryon()) // Final Nucleus is below the splittingFragmentThreshold
-		        {
+          {
 #ifdef mudebug
             G4cout<<"G4QEnv::Const: impossible to split nucleon after mu->nu"<<G4endl;
@@ -331,6 +339,6 @@
             theEnvironment.InitByPDG(90000000);// Create nuclear environment
             return;
-										}
-	       }
+          }
+        }
         // At this poin it is possible to convert mu- to pi-
         fn4m=qf4m-qi4m;
@@ -351,5 +359,5 @@
 #endif
       if(!hNFrag&&ch4M.e()>0.)                // => "Final hadron" case
-	     {
+      {
         G4int envPDG=theEnvironment.GetPDG();
         if(envPDG==90000000||(theEnvironment.Get4Momentum().m2())<1.) // ==>"Vacuum"
@@ -367,8 +375,8 @@
             G4int hQ = curHadr->GetQCode();  // One more check for valid of the QHadron
             if(hQ<0)
-	           {
+            {
               //G4cerr<<"--Warning--G4QEnv::Constructor:Q<0, PDG=("<<ih<<")"<<hPDG<<G4endl;
               //throw G4QException("***G4QEnvironment::Constructor:theInputHadron is bad");
-	           }
+            }
             else
             {
@@ -393,5 +401,5 @@
         }
         else                                  // Nuclear Environment still exists
-		      {
+        {
           G4QContent      hQC   = curHadr->GetQC();
 #ifdef pdebug
@@ -400,6 +408,6 @@
 #endif
           CreateQuasmon(hQC, ch4M,fake);
-		      } // End of Existing Nuclear Environment case
-	     } // End of final hadron case
+        } // End of Existing Nuclear Environment case
+      } // End of final hadron case
     } // End of the LOOP over input hadrons
   } // End of nuclear target case (including neutron=90000001 & proton=90001000)
@@ -419,8 +427,8 @@
       G4int hQ = curHadr->GetQCode();         // One more check for valid of the QHadron
       if(hQ<0)
-	     {
+      {
         G4cout<<"---Warning---G4QEnviron::Constructor:Vacuum,Q<0, 1st HPDG="<<hPDG<<G4endl;
         //throw G4QException("***G4QEnvironment::Constructor:theFirstInputHadron's wrong");
-	     }
+      }
       else                                // Now we can get 4Mom &  QC of incedent particle
       {
@@ -431,10 +439,10 @@
         G4int           tQ    = tQPDG.GetQCode();
         if(tQ<0||targPDG==10)
-		      {
+        {
           G4cout<<"---Warning---G4QEnv::Constructor:TrgQC<0, Chipo?,PDG="<<targPDG<<G4endl;
           //throw G4QException("***G4QEnvironment::Constructor: Target is wrong");
-		      }
+        }
         else                                 // Now we can create a unique Quasmon
-		      {
+        {
           h4Mom+=G4LorentzVector(0.,0.,0.,tQPDG.GetMass()); //Projectile + TargetHadron
           hQC+=tQPDG.GetQuarkContent();
@@ -444,9 +452,9 @@
           G4Quasmon* curQuasmon = new G4Quasmon(hQC, h4Mom);
           theQuasmons.push_back(curQuasmon); // Insert Quasmon or hadron/gamma (del. eq.)
-		      }
+        }
       } // End of Q-Code check
     } // End of proper PDG for i-th Hadron
     if(nHadrons>1) for(G4int ih=0; ih<nHadrons; ih++) // fill other Hadrons to Output
-	   {
+    {
       G4QHadron* newHadr = new G4QHadron(curHadr);
 #ifdef pdebug
@@ -454,5 +462,5 @@
 #endif
       theQHadrons.push_back(newHadr);        // Fill existing hadron (delete equivalent)
-	   }
+    }
   } // End of Unique Hadron target treatment
 #ifdef chdebug
@@ -684,6 +692,8 @@
 {//=======================================================================================
   static const G4double third=1./3.;
-  //static const G4double mNeut= G4QPDGCode(2112).GetMass();
-  //static const G4double mProt= G4QPDGCode(2212).GetMass();
+  static const G4double mNeut= G4QPDGCode(2112).GetMass();
+  static const G4double mNeu2 = mNeut*mNeut;
+  static const G4double mProt= G4QPDGCode(2212).GetMass();
+  static const G4double mPro2 = mProt*mProt;
   //static const G4double mLamb= G4QPDGCode(3122).GetMass();
   static const G4double mPi  = G4QPDGCode(211).GetMass();
@@ -704,5 +714,5 @@
   G4LorentzVector proj4M=pro4M;             // Fake equivalence to avoid & const
   G4double  projE=proj4M.e();               // energy of the projectile
-  G4int projPDG=projQC.GetSPDGCode();     // Minimum hadron for the projectile QC
+  G4int projPDG=projQC.GetSPDGCode();       // Minimum hadron for the projectile QC
   if(projE<0.)
   {
@@ -712,4 +722,6 @@
   }
   G4double  projM2=proj4M.m2();             // projectile's squared mass (print & v.gamma)
+  G4bool Pr1 = theProjectiles.size() == 1;  // A#ofHadronsInTheInputVector = 1 condition
+  if(Pr1 && std::fabs(G4QPDGCode(projPDG).GetMass2()-projM2) > .1 ) Pr1=false; // MassShell
   G4int     targPDG=theEnvironment.GetPDG();// PDG Code of the target nucleus
   if(targPDG>80000000&&targPDG!=90000000&&(theEnvironment.Get4Momentum().m2())>1.)//Nucleus
@@ -730,5 +742,5 @@
     else if(nCl<9) nBarClust=2;
     else
-	   {
+    {
       G4int v=nCl-9;
       G4int d=v/15;
@@ -738,5 +750,5 @@
     }
 #ifdef pdebug
-	   G4cout<<"G4QE::CrQ:TNuc:Z="<<envZ<<",N="<<envN<<",nC="<<nBarClust<<",tC="
+    G4cout<<"G4QE::CrQ:TNuc:Z="<<envZ<<",N="<<envN<<",nC="<<nBarClust<<",tC="
           <<totCharge<<", tB="<<totBaryoN<<G4endl;
 #endif
@@ -751,5 +763,5 @@
     nBarClust=theEnvironment.UpdateClusters(din); // Cluster Probabilities upto maxClust
 #ifdef pdebug
-	   G4cout<<"G4QEnv::CreateQ: Nucleus("<<targPDG<<") is created ("<<nBarClust<<" clast's)";
+    G4cout<<"G4QEnv::CreateQ: Nucleus("<<targPDG<<") is created ("<<nBarClust<<" clast's)";
     for(G4int ic=0;ic<nBarClust;ic++)
       G4cout<<" #"<<ic<<"("<<theEnvironment.GetProbability(ic)<<")";
@@ -759,5 +771,5 @@
     G4QNucleus memEnviron=theEnvironment;
 #ifdef pdebug
-	   G4cout<<"G4QE::CrQ:ClusterProbabCalculation tC="<<totCharge<<",tB="<<totBaryoN<<G4endl;
+    G4cout<<"G4QE::CrQ:ClusterProbabCalculation tC="<<totCharge<<",tB="<<totBaryoN<<G4endl;
 #endif
     G4bool efFlag=false;                    // EnergyFlowFlag=FALSE (@@=DEFOLT=@@ make par)
@@ -767,9 +779,9 @@
     G4LorentzVector ef4Mom(0.,0.,0.,0.);    // Summed 4-momentum of Energy Flux
     G4double proj3M=proj4M.rho();
-    //   ---   Pbar     ---    Nbar  -------  LAMBDAbar  ----  SIGMA-bar  ---  SIGMA0bar
+    // --- P-antibar ---  N-antibar  -- LAMBDA-antibar - SIGMA-antibar - SIGMA0-antibar
     if((projPDG==-2212||projPDG==-2112||projPDG==-3122||projPDG==-3112||projPDG==-3212||
         projPDG==-3222) && envBN>1 && proj3M<10.) // OnlyForAtRestReactions(@@to Interface)
-	   //  ^^^^^  SIGMA+bar
-	   {
+    // ^ SIGMA+ antibar
+    {
       // @@ Annihilation on one baryon is implemented (no annihilation on clusters! @@?) @@
 #ifdef pdebug
@@ -787,21 +799,21 @@
         targNPDG = 90000001;
         targQC   = neutQC;
-	     }
+      }
       else
-						//     if(rnd<=zpn)                      // Proton is a Periferal Target
+      //     if(rnd<=zpn)                      // Proton is a Periferal Target
       {
         targNPDG = 90001000;
         targQC   = protQC;
-	     }
+      }
       //else                                  // Deuteron as a Periferal Target
       //{
       //  targNPDG = 90001001;
       //  targQC   = deutQC;
-	     //}
+      //}
       //else                                  // Lambda is a Periferal Target (?)
       //{
       //  targNPDG = 91000000;
       //  targQC   = lambQC;
-	     //}
+      //}
       theEnvironment.Reduce(targNPDG);      // Subtract periferal baryon from Nucleus
 #ifdef pdebug
@@ -832,5 +844,5 @@
       G4Quasmon::OpenElectromagneticDecays();  // Parameter for multihadronFragmentatation^
 #ifdef pdebug
-	     G4cout<<"G4QE::CrQ:>>AnnihilationIsDone,C="<<totCharge<<",B="<<totBaryoN<<G4endl;// ^
+      G4cout<<"G4QE::CrQ:>>AnnihilationIsDone,C="<<totCharge<<",B="<<totBaryoN<<G4endl;// ^
 #endif
       delete pan;                              // The N-NbarQuasmon is deleted A.S.A.P.   ^
@@ -842,5 +854,5 @@
       G4double ra=std::pow(G4double(totBaryoN),third);  //                              ^ ^
 #ifdef pdebug
-	     G4cout<<"G4QE::CQ:N="<<tNH<<",T="<<totCharge<<","<<totBaryoN<<",A="<<ra<<G4endl;//^ ^
+      G4cout<<"G4QE::CQ:N="<<tNH<<",T="<<totCharge<<","<<totBaryoN<<",A="<<ra<<G4endl;//^ ^
 #endif
       for (G4int ind=0; ind<tNH; ind++)        // Loop over annihilation  QHadrons      ^ ^
@@ -855,5 +867,5 @@
         G4double        shMOM= sh4m.rho();              // Momentum of the projectile   ^ ^
 #ifdef pdebug
-		      G4cout<<"G4QE::CrQ:"<<ind<<","<<shDFL<<",PDG="<<shPDG<<",4M="<<sh4m<<G4endl; // ^ ^
+        G4cout<<"G4QE::CrQ:"<<ind<<","<<shDFL<<",PDG="<<shPDG<<",4M="<<sh4m<<G4endl; // ^ ^
 #endif
         G4double solAnCut=SolidAngle;                   // Proto ChargeDependantSolAngle^ ^
@@ -867,20 +879,20 @@
         //G4double solAnCut=SolidAngle+20*shCHG*sqrt(1.*envZ)/shMOM;//ChargeDepSolAngle ^ ^
 #ifdef pdebug
-		      G4cout<<"G4QE::CrQ: PDG="<<shPDG<<", p="<<shMOM<<", r="<<ra<<G4endl; //         ^ ^
+        G4cout<<"G4QE::CrQ: PDG="<<shPDG<<", p="<<shMOM<<", r="<<ra<<G4endl; //         ^ ^
 #endif
         if(!shDFL)                                      // Final(notDecayed) hadrons    ^ ^
-		      {
-#ifdef pdebug
-		        G4cout<<"G4QE::CQ:>H="<<shPDG<<":"<<dir.dot(shDIR)<<">"<<solAnCut<<G4endl; // ^ ^
-#endif
-		        //if((dir.dot(shDIR)>solAnCut||shMOM<120.) && abs(shPDG)>99) // Absorb mesons ^ ^
-		        if(dir.dot(shDIR)>solAnCut && abs(shPDG)>99) // Absorb mesons                 ^ ^
-		        {
-#ifdef pdebug
-												G4cout<<"G4QE::CQ:>H="<<shPDG<<":"<<dir.dot(shDIR)<<">"<<solAnCut<<", P="// ^ ^
-																		<<shMOM<<" < 120"<<G4endl;                           //               ^ ^
+        {
+#ifdef pdebug
+          G4cout<<"G4QE::CQ:>H="<<shPDG<<":"<<dir.dot(shDIR)<<">"<<solAnCut<<G4endl; // ^ ^
+#endif
+          //if((dir.dot(shDIR)>solAnCut||shMOM<120.) && abs(shPDG)>99) // Absorb mesons ^ ^
+          if(dir.dot(shDIR)>solAnCut && abs(shPDG)>99) // Absorb mesons                 ^ ^
+          {
+#ifdef pdebug
+            G4cout<<"G4QE::CQ:>H="<<shPDG<<":"<<dir.dot(shDIR)<<">"<<solAnCut<<", P="// ^ ^
+                  <<shMOM<<" < 120"<<G4endl;                           //               ^ ^
 #endif
             if(efFlag)                           // => Case of "Energy Flux approach"   ^ ^
-		          {
+            {
               G4QContent shQC = curHadr->GetQC();// QuarkContent of the Current Hadron  ^ ^
               ef4Mom+=sh4m;
@@ -890,9 +902,9 @@
               G4int hPDG=curHadr->GetPDGCode();    // Only for gebug printing           ^ ^
               G4LorentzVector h4M = curHadr->Get4Momentum();  // Only for gebug printing^ ^
-			           G4cout<<"G4QE::CrQ:#"<<efCounter<<", PDG="<<hPDG<<", h4M="<<h4M<<G4endl;//^ ^
-#endif
-		          }
-		          else                                   //=>"MultyQuasFragmentation"(!efFlag)^ ^
-		          {
+              G4cout<<"G4QE::CrQ:#"<<efCounter<<", PDG="<<hPDG<<", h4M="<<h4M<<G4endl;//^ ^
+#endif
+            }
+            else                                   //=>"MultyQuasFragmentation"(!efFlag)^ ^
+            {
               G4QHadron* mqHadron = new G4QHadron(curHadr);
               input.push_back(mqHadron);           // Fill hadron-copy (del equiv)  <...^ ^
@@ -900,14 +912,14 @@
               G4int hPDG=curHadr->GetPDGCode();    // Only for debug printing           ^ ^
               G4LorentzVector h4M = curHadr->Get4Momentum(); // Only for gebug printing ^ ^
-		            G4cout<<"G4QE::CrQ:Absorb#"<<ind<<", PDG="<<hPDG<<", h4M="<<h4M<<G4endl;//^ ^
-#endif
-		          }                                      //                                   ^ ^
-		        }                                        //                                   ^ ^
-		        else                                     // DirectFilling of the output vector^ ^
-		        {                                        //                                   ^ ^
+              G4cout<<"G4QE::CrQ:Absorb#"<<ind<<", PDG="<<hPDG<<", h4M="<<h4M<<G4endl;//^ ^
+#endif
+            }                                      //                                   ^ ^
+          }                                        //                                   ^ ^
+          else                                     // DirectFilling of the output vector^ ^
+          {                                        //                                   ^ ^
 #ifdef pdebug
             G4int hPDG=curHadr->GetPDGCode();      // Only for gebug printing           ^ ^
             G4LorentzVector h4M = curHadr->Get4Momentum(); // Only for gebug printing   ^ ^
-		          G4cout<<"G4QE::CrQ: Fill OUT #"<<ind<<",PDG="<<hPDG<<",h4M="<<h4M<<G4endl;//^ ^
+            G4cout<<"G4QE::CrQ: Fill OUT #"<<ind<<",PDG="<<hPDG<<",h4M="<<h4M<<G4endl;//^ ^
 #endif
             // Just fill a hadron to the output stack (One should make EM decays elsewhere)
@@ -915,14 +927,14 @@
             theQHadrons.push_back(curHadron);      // TheQHadrs are filled as new Hadrs ^ ^
           }
-		      } // End of the IF over projectiles                                             ^ ^
-	     } // End of LOOP over "output" of annihilation                                    ^ ^
+        } // End of the IF over projectiles                                             ^ ^
+      } // End of LOOP over "output" of annihilation                                    ^ ^
       for_each(output->begin(), output->end(), DeleteQHadron());     //DESTRUCT output>-^-^
       output->clear();                             //                                   ^ ^
       delete output;                               // ==================================^=^
       if(!efFlag)                                  // =>NotEnergyFlux=MultyQuasmon Case ^
-	     {
+      {
         G4int noh = theQHadrons.size();            // a#oh hadrons in Output UpToNow    ^
         if(noh) for(G4int kh=0; kh<noh; kh++)      // One can escape it but...          ^
-								{                                          //                                   ^
+        {                                          //                                   ^
 #ifdef pdebug
           G4cout<<"G4QE::CreateQ:H#"<<kh<<", QC="<<theQHadrons[kh]->GetQC() //          ^
@@ -935,19 +947,19 @@
           tmpQHadVec->clear();                     //                                 ^ ^
           delete tmpQHadVec;           // who calls DecayQHadron must clear & delete  ^ ^
-		      }                                          //                                 ^ ^
+        }                                          //                                 ^ ^
         theQHadrons.clear(); // deletedWhenDecayed // Now theQHadrons is EmptyVector->^ ^
 #ifdef pdebug
         G4int nInH=intQHadrons.size();             // Resulting #of hadrons after decay ^
-	       G4cout<<"G4QE::CrQ:nH="<<nInH<<",C="<<totCharge<<",B="<<totBaryoN<<G4endl;//    ^
+        G4cout<<"G4QE::CrQ:nH="<<nInH<<",C="<<totCharge<<",B="<<totBaryoN<<G4endl;//    ^
 #endif
         if(!(input.size()))                        // *RETURN* Without Quasmon creation-^
-		      {                                          //                                   ^
-#ifdef pdebug
-	         G4cout<<"*G4QEnv::CrQ:AnnihStack tC="<<totCharge<<",tB="<<totBaryoN<<G4endl;//^
-#endif
-		        return;                                  // Do not clear and delete objects --^
+        {                                          //                                   ^
+#ifdef pdebug
+          G4cout<<"*G4QEnv::CrQ:AnnihStack tC="<<totCharge<<",tB="<<totBaryoN<<G4endl;//^
+#endif
+          return;                                  // Do not clear and delete objects --^
         }                                          //                                   ^
 #ifdef pdebug
-	       G4cout<<"G4QE::CrQ:fakeQ, restPars tC="<<totCharge<<",tB="<<totBaryoN<<G4endl;//^
+        G4cout<<"G4QE::CrQ:fakeQ, restPars tC="<<totCharge<<",tB="<<totBaryoN<<G4endl;//^
 #endif
         G4Quasmon::SetParameters(QTemper,QSOverU,QEtaSup);//RecoverQParam's after anihil^
@@ -956,5 +968,5 @@
         G4QEnvironment* muq = new G4QEnvironment(input,theEnvironment.GetPDG());//<--+  ^
 #ifdef pdebug
-	       G4cout<<"G4QE::CrQ:befCl&Dest tC="<<totCharge<<", tB="<<totBaryoN<<G4endl; //^  ^
+        G4cout<<"G4QE::CrQ:befCl&Dest tC="<<totCharge<<", tB="<<totBaryoN<<G4endl; //^  ^
 #endif
         for_each(input.begin(), input.end(), DeleteQHadron());     //DESTROING inp >-^--^
@@ -969,5 +981,5 @@
 #endif
         if(noh) for(G4int nh=0; nh<noh; nh++)      // One can escape it but...          ^ ^
-								{                                          //                                   ^ ^
+        {                                          //                                   ^ ^
 #ifdef pdebug
           G4cout<<"G4QE::CreateQ: NotIntQH#"<<nh<<", QC="<<(*outH)[nh]->GetQC()  //     ^ ^
@@ -980,24 +992,24 @@
           tmpQHadVec->clear();                     //                                 ^ ^ ^
           delete tmpQHadVec;           // who calls DecayQHadron must clear & delete->+ ^ ^
-		      }                                          //                                   ^ ^
+        }                                          //                                   ^ ^
         outH->clear();                             //                                   ^ ^
         delete outH;                               // >---->---->---->---->---->---->---^-+
-	       G4int nMQ = outQ->size();                  // A#ofQuasmons in MultyQuasmonOutput^
+        G4int nMQ = outQ->size();                  // A#ofQuasmons in MultyQuasmonOutput^
 #ifdef pdebug
         G4LorentzVector eLorV=theEnvironment.Get4Momentum(); //                         ^
-	       G4cout<<"G4QE::CrQ:nMQ="<<nMQ<<",tC="<<totCharge<<", tB="<<totBaryoN<<G4endl;// ^
-	       G4cout<<"G4QE::CrQ:Env4M="<<eLorV<<G4endl; //                                   ^
+        G4cout<<"G4QE::CrQ:nMQ="<<nMQ<<",tC="<<totCharge<<", tB="<<totBaryoN<<G4endl;// ^
+        G4cout<<"G4QE::CrQ:Env4M="<<eLorV<<G4endl; //                                   ^
         G4LorentzVector contr4M=eLorV; //                                               ^
 #endif
         if(nMQ) for(G4int mh=0; mh<nMQ; mh++)      // Can escape CreationDistruct but...^
-								{                                          //                                   ^
+        {                                          //                                   ^
           G4Quasmon* curQ = new G4Quasmon((*outQ)[mh]);// Copy to destroy TMP(?)        ^
 #ifdef pdebug
           G4LorentzVector qLorV=curQ->Get4Momentum(); //                                ^
-	         G4cout<<"G4QE::CrQ:Q#"<<mh<<",4M="<<qLorV<<curQ->GetQC()<<G4endl; //          ^
+          G4cout<<"G4QE::CrQ:Q#"<<mh<<",4M="<<qLorV<<curQ->GetQC()<<G4endl; //          ^
           contr4M+=qLorV; //                                                            ^
 #endif
           theQuasmons.push_back(curQ);             // Fill QuasmonCopies in theQuasmons ^
-	       }                                          //                                   ^
+        }                                          //                                   ^
         for_each(outQ->begin(), outQ->end(), DeleteQuasmon()); // >---------------------^
         outQ->clear();                             //                                   ^
@@ -1005,13 +1017,13 @@
 #ifdef pdebug
         G4int nsHadr  = theQHadrons.size();      // Update the value of OUTPUT entries
-	       G4cout<<"G4QEnvironment::CreateQ: before return nH="<<nsHadr<<G4endl;
+        G4cout<<"G4QEnvironment::CreateQ: before return nH="<<nsHadr<<G4endl;
         if(nsHadr) for(G4int jso=0; jso<nsHadr; jso++)// LOOP over output hadrons 
         {
           G4int hsNF  = theQHadrons[jso]->GetNFragments(); // A#of secondary fragments
           if(!hsNF)                                        // Add only final hadrons
-										{
+          {
             G4LorentzVector hLorV=theQHadrons[jso]->Get4Momentum();
             G4int           hPDGC=theQHadrons[jso]->GetPDGCode();
-          		G4cout<<"G4QE::CrQ: H#"<<jso<<",4M="<<hLorV<<hPDGC<<G4endl;
+            G4cout<<"G4QE::CrQ: H#"<<jso<<",4M="<<hLorV<<hPDGC<<G4endl;
             contr4M+=hLorV;
           }
@@ -1019,13 +1031,13 @@
             G4cout<<"G4Q::CrQ:"<<jso<<"NF=0,4M="<<theQHadrons[jso]->Get4Momentum()<<G4endl;
         }
-	       G4cout<<"G4QEnvironment::CreateQ: before return tot4M="<<contr4M<<G4endl;
+        G4cout<<"G4QEnvironment::CreateQ: before return tot4M="<<contr4M<<G4endl;
 #endif
         return;                                    // *** RETURN *** 
       }
       else                                         // ==> Energy Flux case
-	     {
+      {
         if (!efCounter) return;                    // ***RETURN*** Without Quasmon creation
-	     }
-	   }                                              // End of Hyperon annihilation case
+      }
+    }                                              // End of Hyperon annihilation case
     else EnFlQC=projQC;                            // For notAntiBar, don't use EnergyFlux
     G4double EnFlP=ef4Mom.rho();                   // Mom. of EnergyFlow forClusterCreation
@@ -1033,5 +1045,5 @@
     G4int nCandid = theQCandidates.size();
 #ifdef pdebug
-	   G4cout<<"G4QEnvironment::CrQ: InteractionProbabilities are done, nC="<<nCandid<<G4endl;
+    G4cout<<"G4QEnvironment::CrQ: InteractionProbabilities are done, nC="<<nCandid<<G4endl;
 #endif
     G4double maxP = theQCandidates[nCandid-1]->GetIntegProbability();
@@ -1039,13 +1051,13 @@
     G4QContent    curQC;                           // Quark Content of the selected cluster
     if(nCandid<=0)
-	   {
-	     G4cout<<"---Warning---G4QEnv::CreaQ:nC="<<nCandid<<",maxP="<<maxP<<",E="
+    {
+      G4cout<<"---Warning---G4QEnv::CreaQ:nC="<<nCandid<<",maxP="<<maxP<<",E="
             <<theEnvironment<<G4endl;
       //throw G4QException("G4QEnvironment::CreateQ: Can not select a cluster");
-	   }
+    }
     if(nCandid==1||maxP==0.)
-	   {
-#ifdef pdebug
-	     G4cout<<"***G4QEnv::CrQ:MaxP=0||nCand=1: Use all Env., Env="<<theEnvironment<<G4endl;
+    {
+#ifdef pdebug
+      G4cout<<"***G4QEnv::CrQ:MaxP=0||nCand=1: Use all Env., Env="<<theEnvironment<<G4endl;
 #endif
       curQC=theEnvironment.GetQCZNS();
@@ -1056,5 +1068,5 @@
       G4double totP = maxP * G4UniformRand();
 #ifdef pdebug
-	     G4cout<<"G4QEnvironment::CrQ:nC="<<nCandid<<", maxP="<<maxP<<", totP="<<totP<<G4endl;
+      G4cout<<"G4QEnvironment::CrQ:nC="<<nCandid<<", maxP="<<maxP<<", totP="<<totP<<G4endl;
 #endif
       while(theQCandidates[i]->GetIntegProbability()<totP) i++;
@@ -1064,22 +1076,22 @@
       G4double clMass=targClust.GetGSMass();    // Mass of residual nuclear environment
 #ifdef cldebug
-	     G4cout<<"G4QEnv::CrQ:Cl#"<<i<<"(of "<<nCandid<<"),QC="<<curQC<<",M="<<clMass<<G4endl;
+      G4cout<<"G4QEnv::CrQ:Cl#"<<i<<"(of "<<nCandid<<"),QC="<<curQC<<",M="<<clMass<<G4endl;
 #endif
       G4LorentzVector pq4M=proj4M+G4LorentzVector(0.,0.,0.,clMass); 
       if(pq4M.m()>=clMass)
-	     {
-#ifdef pdebug
-	       G4cout<<"G4QEnv::CQ:#"<<i<<"("<<targClust<<curQC<<") Env="<<theEnvironment<<G4endl;
+      {
+#ifdef pdebug
+        G4cout<<"G4QEnv::CQ:#"<<i<<"("<<targClust<<curQC<<") Env="<<theEnvironment<<G4endl;
 #endif
         theEnvironment.Reduce(targClust.GetPDG());// Subtract selected cluster from Nucleus
-	     }
+      }
       else
-	     {
+      {
         G4double teMass=theEnvironment.GetGSMass(); //Mass of theResidualNuclearEnvironment
         G4LorentzVector te4M=proj4M+G4LorentzVector(0.,0.,0.,teMass);
         if(te4M.m()>=teMass)
-	       {
-#ifdef pdebug
-	         G4cout<<"***G4QEnv::CrQ: Deep virtual, use all Env,Env="<<theEnvironment<<G4endl;
+        {
+#ifdef pdebug
+          G4cout<<"***G4QEnv::CrQ: Deep virtual, use all Env,Env="<<theEnvironment<<G4endl;
 #endif
           curQC=theEnvironment.GetQCZNS();
@@ -1087,16 +1099,17 @@
         }
         else
-		      {
+        {
           G4QHadron* projH = new G4QHadron(projQC,proj4M);
           theQHadrons.push_back(projH);
-	         G4cout<<"---Warning---G4QE::CrQ:Fill Proj asItIs QC/4m="<<projQC<<proj4M<<G4endl;
+          G4cout<<"---Warning---G4QE::CrQ:Fill Proj asItIs QC/4m="<<projQC<<proj4M<<G4endl;
           return;
         }
-	     }
-	   }
+      }
+    }
     G4double envMass=theEnvironment.GetGSMass();   // Mass of residual nuclear environment
-    if(projPDG==22&&projE<PiPrThresh+(M2ShiftVir+projM2)/DiNuclMass) // Gam+quark Interact
+    // @@ Pr1 condition (individual particle) can be taken out of brackets for all if's
+    if(Pr1&&projPDG==22&&projE<PiPrThresh+(M2ShiftVir+projM2)/DiNuclMass) // ==> Gamma+q
     //if(2>3)                                      //@@ TMP:PhotoAbsorbtion by q is closed
-	   {
+    {
       q4Mom=G4LorentzVector(0.,0.,0.,tgMass-envMass);// PhotoInteracts with BoundedCluster
       valQ=curQC;
@@ -1106,8 +1119,8 @@
       G4Quasmon* curQuasmon = new G4Quasmon(valQ, q4Mom, proj4M);//Interaction gam+q inside
       theQuasmons.push_back(curQuasmon);  // Insert Quasmon without incid. gamma (del.eq.)
-	   }
-    else if((projM2-mPi2<.00001&&projE-mPi<0.1)&&projPDG==-211&&!fake)
+    }
+    else if(Pr1&&(std::fabs(projM2-mPi2)<.00001 && projE-mPi<0.1) && projPDG==-211 &&!fake)
     //if(2>3)                                //@@ ***TMP*** PionAbsorbAtRest by q is closed
-	   {
+    {
       q4Mom=proj4M+G4LorentzVector(0.,0.,0.,tgMass-envMass);// PION + BoundCluster
       valQ=EnFlQC+curQC;
